// Cyrus Harrison (cdh@cise.ufl.edu)
// JMF Dice Analyzing Codec
import java.awt.*;
import javax.swing.*;
import javax.media.*;
import javax.media.control.TrackControl;
import javax.media.Format;
import javax.media.format.*;
import java.io.*;


	/**
    * Callback to access individual video frames.
    */
    public class DiceAnalysis implements Codec {



	private static int MAX_SAMPLES=15;
	
	private int width;
	private int height;
	private int samp_num;
	private Ranzor host;
	private boolean SAMPLE;
	private int[] samples;
	private int result;

	

	public DiceAnalysis(Ranzor host) 
	{
	 width=320;height=240;
	 result=0;
	 samples=new int[MAX_SAMPLES];
	 samp_num=0;
	 this.host=host;
	}


	public int result(){return result;}	
	public void beginSample(){SAMPLE=true;}

	void accessFrame(Buffer frame) {
		
		if(SAMPLE)
		{
			byte[] b;	
			Class c=frame.getData().getClass();
			b=(byte[])frame.getData();
	
			Matrix2d bin_data=null;
			bin_data=lowLightHL(b);
		
			int value=cc_die_face(bin_data);
			System.out.println("Value: " + value);
			samples[samp_num]=value;
			
			frame.setData(b);
			samp_num++;

				if(samp_num==MAX_SAMPLES)
					{
					host.sample_update_callback(mode(samples));
					samp_num=0;
					}
		}

	}

	public int mode(int[] arrayx)
	{
		int occur=0;
		int max=0;
		int mode=0;

		for(int j=0;j<arrayx.length;j++)
		{
			for(int i=0;i<arrayx.length;i++)
				{
				if(arrayx[j]==arrayx[i])
					{occur++;}
				}
			if(occur>max)
				{max=occur;mode=arrayx[j];}
			occur=0;
		}

		return mode;
	}

	/*Filters out anything that isnt dark*/
	public Matrix2d lowLightHL(byte[] b)
		{
			Matrix2d data=new Matrix2d(width,height);
			int pix_count=0;
			for(int i=0;i<b.length;i++)
			{
				if(b[i]>5)
				{b[i]=(byte)255;}else{b[i]=(byte)0;}
			
			}

			int ii=0;
			int jj=0;

			for(int j=0;j<b.length;j=j+3)
			{

				if((b[j]==(byte)255)&&(b[j+1]==(byte)255)&&(b[j+2]==(byte)255))
				{
					data.set(ii,jj,(byte)1);
					pix_count++;
				}

				ii++;
				if(ii==(width))
				{ii=0;jj++;}
				
			}
		
			return data;

		}
 


	/*Does the connected components analysis on the prefiltered data*/
	public int cc_die_face(Matrix2d mat)
		{
		
		int comp_num=1;
		
		int ul=0;
		int ur=0;
		int t=0;
		int l=0;

		int width=mat.getWidth();
		int height=mat.getHeight();
		
		Matrix2d mark=new Matrix2d(width,height);

		
		for(int j=0;j<height;j++)
			{
			for(int i=0;i<width;i++)
				{
					if(mat.get(i,j)==(byte)1)
					{
						ur=0;
						ul=0;
						t=0;
						l=0;

						if(j!=0&&i!=(width-1)){ur=mark.get(i+1,j-1);}
						if(i!=0&&j!=0){ul=mark.get(i-1,j-1);}
						if(i!=0){l=mark.get(i-1,j);}
						if(j!=0){t=mark.get(i,j-1);}
			
						if((ur|ul|l|t)==0)
						{
						mark.set(i,j,comp_num);
						comp_num++;
						}else{
						
						if((t!=0)&&(l!=0))
								{		
										
									if((t!=l))
									{	
										mark.set(i,j-1,(byte)l);
										t=l;
									}
		
								}
						if((t!=0)&&(ul!=0))
							{
								if(t!=ul)
								{
									mark.set(i,j-1,(byte)ul);
								}
							}

						if((t!=0)&&(ur!=0))
							{
								if(t!=ur)
								{
									mark.set(i+1,j-1,(byte)t);
								}
							}


						if(ur!=0){mark.set(i,j,(byte)ur);}
						if(t!=0){mark.set(i,j,(byte)t);}
						if(ul!=0){mark.set(i,j,(byte)ul);}
						if(l!=0){mark.set(i,j,(byte)l);}

						
						}



					}// end if for input matrix pix check	
				}// end width for
			}// end height for


		for(int i=width-1;i>=0;i--)
			{
				for(int j=height-1;j>0;j--)
				{
					int val=mark.get(i,j);
					if(val!=0)
					{
						if(mark.get(i,j-1)!=0)
						{
						if(mark.get(i,j-1)!=val)
						{mark.set(i,j-1,(byte)val);}
						}
					}
				}
			}
		
		int[] count=new int[comp_num-1];
		int val=0;
		
		for(int j=0;j<height;j++)
			{
		for(int i=0;i<width;i++)
			{
				val=(int)mark.get(i,j);

				if(val<0){val+=255;}
	
				if(val!=0&&(val-1)<count.length)
				{count[val-1]++;}
				
				
			}
			}
		
		int die_face=0;
		for(int i=0;i<count.length;i++)
			{
			if(count[i]>170)
				{die_face++;}
			}

		die_face--;
		return die_face;
		}



	/*Used to Color Components for debugging, not necessary in final filter*/
	public byte[] color_components(Matrix2d mat,byte[] b)
		{
			int height=mat.getHeight();
			int width=mat.getWidth();
		int ii=b.length-1;
		
		for(int j=0;j<height;j++)
			{
			for(int i=0;i<width;i++)
			{
				if(mat.get(i,j)!=0)
				{

					b[ii-2]=(byte)255;
					b[ii-1]=(byte)0;
					b[ii]=(byte)0;
				}
			ii-=3;
			}
			}

		return b;
		}

	Format input = null, output = null;

	/* More Cookie Cutter Interface Stuff */
	protected Format supportedIns[] = new Format [] { new VideoFormat(null)};
	protected Format supportedOuts[] = new Format [] { new VideoFormat(null)};
	public String getName() {return "Extracts Die Face Value";}
	/*Blank Ops exist to uphold the Codec Interface*/
    public void open() {}
	public void close() {}
	public void reset() {}
    public Object[] getControls() {return new Object[0];}
	public Object getControl(String type) {return null;}
	public Format [] getSupportedInputFormats() {return supportedIns;}
	public Format [] getSupportedOutputFormats(Format in) {
	    if (in == null)
		return supportedOuts;
	    else {
		Format outs[] = new Format[1];
		outs[0] = in;
		return outs;
	    }
	}

	public Format setInputFormat(Format format){input = format; return input;}
	public Format setOutputFormat(Format format){output = format; return output;}

	public int process(Buffer in, Buffer out) {

	    // This is the "Callback" to access individual frames.
	    accessFrame(in);

	    // Swap the data between the input & output.
	    Object data = in.getData();
	    in.setData(out.getData());
	    out.setData(data);

	    // Copy the input attributes to the output
	    out.setFormat(in.getFormat());
	    out.setLength(in.getLength());
	    out.setOffset(in.getOffset());

	    return BUFFER_PROCESSED_OK;
	}

	
    }

