/*	Ranor's Main App */
// Cyrus Harrison (cdh@cise.ufl.edu)
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.media.*;
import javax.media.control.TrackControl;
import javax.media.Format;
import javax.media.format.*;


/**
Main GUI Class
 */

 /* url for cap=vfw://0 */
public class Ranzor extends Frame implements ControllerListener , ActionListener{

    Processor p;
	PPort	  rf;
    Object waitSync = new Object();
    boolean stateTransitionOK = true;
	DiceAnalysis	da;
	JButton start, fw,bw,left,right,stop;
	JTextField txt_disp;
	JPanel lside, drive_panel;

    /**
     * Tons of Cookie Cutter Java Media Stuff
	 */

	public Ranzor(String url)
	{super();
	rf=new PPort();
		
		MediaLocator ml;
		if ((ml = new MediaLocator(url)) == null) 
		{
			System.err.println("Cannot build media locator from: " + url);
			System.exit(0);
		}

	if (!this.open(ml)) System.exit(0);
	
	da.beginSample(); 
	}

	 public void actionPerformed(ActionEvent event)
	{
		Object source = event.getSource();
		if(source == start)
			{da.beginSample();}
	 }
	
	public void sample_update_callback(int val)
	{
		long timex=System.currentTimeMillis();
		if(val==0)
		{
		 txt_disp.setText("Waiting for Sample");
		 
		 rf.out(0x0);
		 System.out.println("Sending 0x0");

		}
		else if(val < 0 || val > 6)
		{
			txt_disp.setText("Error");
			rf.out(0x0);
		 System.out.println("Sending 0x0");
		}
		else
		{
		txt_disp.setText("Face Value: " + val);
		rf.out(rev_bits_lower_nibble((byte)val));
		rf.out(rev_bits_lower_nibble((byte)val));
		}

	}

/*Reverses Nibble order because I wired it backwards*/
	public byte rev_bits_lower_nibble(byte val)
	{byte ret=0;
	if((0x8 & val) !=0 ){ret=(byte)(ret |  0x1);}
	if((0x4 & val) !=0 ){ret=(byte)(ret |  0x2);}
	if((0x2 & val) !=0 ){ret=(byte)(ret |  0x4);}
	if((0x1 & val) !=0 ){ret=(byte)(ret |  0x8);}
	return ret;
	}

/* More Cookie Cutter */
    public boolean open(MediaLocator ml) {
	
	try {p = Manager.createProcessor(ml);} catch (Exception e) {
	    System.err.println("Failed to create a processor from the given url: " + e);
	    return false;}

	p.addControllerListener(this);

	p.configure();
	if (!waitForState(p.Configured)) {
	    System.err.println("Failed to configure the processor.");
	    return false;}


	p.setContentDescriptor(null);


	TrackControl tc[] = p.getTrackControls();

	if (tc == null) {
	    System.err.println("Failed to obtain track controls from the processor.");
	    return false;
	}

	TrackControl videoTrack = null;

	for (int i = 0; i < tc.length; i++) 
	{
	    if (tc[i].getFormat() instanceof VideoFormat) {
		videoTrack = tc[i];
		break;
	    }
	}

	if (videoTrack == null) 
	{
	    System.err.println("The input media does not contain a video track.");
	    return false;
	}

	System.err.println("Video format: " + videoTrack.getFormat());

	// Instantiate and set the frame access codec to the data flow path.
	try {
		da=new DiceAnalysis(this);
	    Codec codec[] = { da};			
	    videoTrack.setCodecChain(codec);
	} catch (UnsupportedPlugInException e) {
	    System.err.println("The process does not support effects.");
	}

	// Realize the processor.
	p.prefetch();
	if (!waitForState(p.Prefetched)) 
	{
	    System.err.println("Failed to realize the processor.");
	    return false;
	}

	// Setup GUI

	setLayout(new BorderLayout());
	
	Component cc;
	Component vc;
	
	lside=new JPanel();
	drive_panel=new JPanel();
	lside.setLayout(new BorderLayout());
	//drive_panel.setLayout(new BorderLayout());
	txt_disp=new JTextField();
	txt_disp.setFont(new Font(null,0,30));
	start=new JButton("Sample Face Value");


	start.addActionListener(this);


	lside.add("Center",txt_disp);


	if ((vc = p.getVisualComponent()) != null){add("Center", vc);}
	if ((cc = p.getControlPanelComponent()) != null){add("South", cc);}

	add("East",lside);

	addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });


	// Start the processor.
	p.start();

	setVisible(true);

	return true;
    }

    public void addNotify() {
	super.addNotify();
	pack();
    }


    /**
     * Block until the processor has transitioned to the given state.
     * Return false if the transition failed.
     */
    boolean waitForState(int state) {
	synchronized (waitSync) {
	    try {
		while (p.getState() != state && stateTransitionOK)
		    waitSync.wait();
	    } catch (Exception e) {}
	}
	return stateTransitionOK;
    }


    /**
     * Controller Listener.
     */
    public void controllerUpdate(ControllerEvent evt) {

	if (evt instanceof ConfigureCompleteEvent ||
	    evt instanceof RealizeCompleteEvent ||
	    evt instanceof PrefetchCompleteEvent) {
	    synchronized (waitSync) {
		stateTransitionOK = true;
		waitSync.notifyAll();
	    }
	} else if (evt instanceof ResourceUnavailableEvent) {
	    synchronized (waitSync) {
		stateTransitionOK = false;
		waitSync.notifyAll();
	    }
	} else if (evt instanceof EndOfMediaEvent) {
	    p.close();
	    System.exit(0);
	}
    }



    /**
     * Main program
     */
    public static void main(String [] args) 
	{
		
		if (args.length == 0) {prUsage(); System.exit(0);}
		String url = args[0];
		if (url.indexOf(":") < 0) {prUsage(); System.exit(0);}
		

	Ranzor fa = new Ranzor(url);

    }

    static void prUsage() {	System.err.println("Usage: java DiceFilter <url>");}



    
}

